﻿Imports System.Data.OleDb

Public Class Form1
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles Me.Load
        C1FlexGrid1.DataSource = GetDataTable("select OrderID, CustomerID, EmployeeID, OrderDate, ShippedDate from Orders")

        'ComboBox with simple values
        Dim comboEmployee = New ComboBox()
        comboEmployee.DataSource = GetDataTable("select EmployeeID from Employees")
        comboEmployee.DisplayMember = "EmployeeID"

        C1FlexGrid1.Cols("EmployeeID").Editor = comboEmployee

        'ComboBox with mapped values (key-value pair) from a table
        Dim comboCustomer = New ComboBox()
        Dim customerTable = GetDataTable("select CustomerID, CompanyName from Customers")
        comboCustomer.DataSource = customerTable
        comboCustomer.DisplayMember = "CompanyName"
        comboCustomer.ValueMember = "CompanyName"
        C1FlexGrid1.Cols("CustomerID").Editor = comboCustomer

        Dim dictionary = New Dictionary(Of String, String)()
        For row = 0 To customerTable.Rows.Count - 1
            dictionary.Add(customerTable(row)("CustomerID"), customerTable(row)("CompanyName"))
        Next
        C1FlexGrid1.Cols("CustomerID").DataMap = dictionary
        C1FlexGrid1.Cols("CustomerID").Caption = "Customer"
    End Sub

    Private Function GetDataTable(query As String) As DataTable
        Dim connectionString = GetConnectionString()
        Dim adapter = New OleDbDataAdapter(query, connectionString)
        Dim table = New DataTable()
        adapter.Fill(table)

        Return table
    End Function

    Private Function GetConnectionString() As String
        Dim path = Environment.GetFolderPath(Environment.SpecialFolder.Personal) + "\ComponentOne Samples\Common"
        Dim conn = "Provider=Microsoft.Jet.OLEDB.4.0; Data Source={0}\\C1NWind.mdb"
        Return String.Format(conn, path)
    End Function
End Class
